//
// Created by zx on 23-8-4.
//

#ifndef FAST_LIO_SAM_KEYFRAMESMANAGER_H
#define FAST_LIO_SAM_KEYFRAMESMANAGER_H
#include "preprocess.h"
typedef pcl::PointXYZINormal PointType;
typedef pcl::PointCloud<PointType> PointCloudXYZI;
class keyFrame{
public:
    keyFrame(PointCloudXYZI::Ptr cloud);
    keyFrame(PointTypePose pose,PointCloudXYZI::Ptr cloud);
    keyFrame(const keyFrame& frame);
    keyFrame& operator=(const keyFrame& frame);
    ~keyFrame();
    void ResetPose(PointTypePose pose);
    PointTypePose Pose(){return pose_;}
    PointCloudXYZI::Ptr cloud(){return cloud_;}
    PointCloudXYZI::Ptr world_cloud(Eigen::Isometry3d lidar_2_imu );
protected:
    PointTypePose pose_;
    PointCloudXYZI::Ptr cloud_;
    PointCloudXYZI::Ptr cloud_world_;
    bool pose_changed_;
    std::mutex lock_;
};

class keyFramesManager {
public:
    keyFramesManager();
    ~keyFramesManager();
    int size(){return frames_.size();}
    keyFrame& back(){return frames_.back();}
    void push_back(const keyFrame& frame){frames_.push_back(frame);}
    pcl::PointCloud<PointTypePose>::Ptr GetPoses();
    keyFrame& operator[](int id){ return frames_[id];}

    std::vector<keyFrame> frames_;

};

#endif //FAST_LIO_SAM_KEYFRAMESMANAGER_H
